# coding: utf-8

"""
    LEO Station Keeping API

    This mission allows to estimate the cost of station keeping maneuvers needed  to counter the effects of the atmospheric drag on the semi-major axis of a  spacecraft in low Earth orbit (up to an altitude of 1000 km).   <b>CHANGELOG</b> <ul>   <li><b>1.6.0</b> - 2024-07-15 - Add <b>Battery</b> schema to inputs of <b>NumericalLeoStationKeepingRequest</b> schema</li>, update SolarArray efficiency description, added SYSTEM output ephemerides type, corrected <b>onBoardAveragePower</b> description</li>   <li><b>1.5.0</b> - 2024-07-08 - Replace custom earth potential data with <b>customEarthPotentialConfiguration</b> in <b>EarthPotentialPerturbation</b> schema</li>   <li><b>1.4.0</b> - 2024-07-08 - Add <b>efficiency</b> to <b>SolarArray</b> schema</li>   <li><b>1.3.0</b> - 2024-07-08 - Replace <b>missionDateTime</b> by <b>initialDate</b> in <b>NumericalLeoStationKeepingRequest</b> schema</li>    <li><b>1.2.0</b> - 2024-07-03 - Add <b>atmosphericModel</b> to <b>DragPerturbation</b> schema</li>   <li><b>1.1.0</b> - 2024-06-27 - Map custom maneuvering strategy</li>   <li><b>1.0.0</b> - 2024-06-07 - First version of the API</li> </ul> 

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from setuptools import setup, find_packages  # noqa: H301

# To install the library, run the following
#
# python setup.py install
#
# prerequisite: setuptools
# http://pypi.python.org/pypi/setuptools
NAME = "leo-station-keeping"
VERSION = "1.6.0"
PYTHON_REQUIRES = ">=3.7"
REQUIRES = [
    "urllib3 >= 1.25.3, < 2.1.0",
    "python-dateutil",
    "pydantic >= 2",
    "typing-extensions >= 4.7.1",
]

setup(
    name=NAME,
    version=VERSION,
    description="LEO Station Keeping API",
    author="OpenAPI Generator community",
    author_email="team@openapitools.org",
    url="",
    keywords=["OpenAPI", "OpenAPI-Generator", "LEO Station Keeping API"],
    install_requires=REQUIRES,
    packages=find_packages(exclude=["test", "tests"]),
    include_package_data=True,
    license="Exotrail",
    long_description_content_type='text/markdown',
    long_description="""\
    This mission allows to estimate the cost of station keeping maneuvers needed  to counter the effects of the atmospheric drag on the semi-major axis of a  spacecraft in low Earth orbit (up to an altitude of 1000 km).   &lt;b&gt;CHANGELOG&lt;/b&gt; &lt;ul&gt;   &lt;li&gt;&lt;b&gt;1.6.0&lt;/b&gt; - 2024-07-15 - Add &lt;b&gt;Battery&lt;/b&gt; schema to inputs of &lt;b&gt;NumericalLeoStationKeepingRequest&lt;/b&gt; schema&lt;/li&gt;, update SolarArray efficiency description, added SYSTEM output ephemerides type, corrected &lt;b&gt;onBoardAveragePower&lt;/b&gt; description&lt;/li&gt;   &lt;li&gt;&lt;b&gt;1.5.0&lt;/b&gt; - 2024-07-08 - Replace custom earth potential data with &lt;b&gt;customEarthPotentialConfiguration&lt;/b&gt; in &lt;b&gt;EarthPotentialPerturbation&lt;/b&gt; schema&lt;/li&gt;   &lt;li&gt;&lt;b&gt;1.4.0&lt;/b&gt; - 2024-07-08 - Add &lt;b&gt;efficiency&lt;/b&gt; to &lt;b&gt;SolarArray&lt;/b&gt; schema&lt;/li&gt;   &lt;li&gt;&lt;b&gt;1.3.0&lt;/b&gt; - 2024-07-08 - Replace &lt;b&gt;missionDateTime&lt;/b&gt; by &lt;b&gt;initialDate&lt;/b&gt; in &lt;b&gt;NumericalLeoStationKeepingRequest&lt;/b&gt; schema&lt;/li&gt;    &lt;li&gt;&lt;b&gt;1.2.0&lt;/b&gt; - 2024-07-03 - Add &lt;b&gt;atmosphericModel&lt;/b&gt; to &lt;b&gt;DragPerturbation&lt;/b&gt; schema&lt;/li&gt;   &lt;li&gt;&lt;b&gt;1.1.0&lt;/b&gt; - 2024-06-27 - Map custom maneuvering strategy&lt;/li&gt;   &lt;li&gt;&lt;b&gt;1.0.0&lt;/b&gt; - 2024-06-07 - First version of the API&lt;/li&gt; &lt;/ul&gt; 
    """,  # noqa: E501
    package_data={"leo_station_keeping": ["py.typed"]},
)
