# coding: utf-8

"""
    LEO Station Keeping API

    This mission allows to estimate the cost of station keeping maneuvers needed  to counter the effects of the atmospheric drag on the semi-major axis of a  spacecraft in low Earth orbit (up to an altitude of 1000 km).   <b>CHANGELOG</b> <ul>   <li><b>1.6.0</b> - 2024-07-15 - Add <b>Battery</b> schema to inputs of <b>NumericalLeoStationKeepingRequest</b> schema</li>, update SolarArray efficiency description, added SYSTEM output ephemerides type, corrected <b>onBoardAveragePower</b> description</li>   <li><b>1.5.0</b> - 2024-07-08 - Replace custom earth potential data with <b>customEarthPotentialConfiguration</b> in <b>EarthPotentialPerturbation</b> schema</li>   <li><b>1.4.0</b> - 2024-07-08 - Add <b>efficiency</b> to <b>SolarArray</b> schema</li>   <li><b>1.3.0</b> - 2024-07-08 - Replace <b>missionDateTime</b> by <b>initialDate</b> in <b>NumericalLeoStationKeepingRequest</b> schema</li>    <li><b>1.2.0</b> - 2024-07-03 - Add <b>atmosphericModel</b> to <b>DragPerturbation</b> schema</li>   <li><b>1.1.0</b> - 2024-06-27 - Map custom maneuvering strategy</li>   <li><b>1.0.0</b> - 2024-06-07 - First version of the API</li> </ul> 

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from leo_station_keeping.models.analytical_leo_station_keeping_response import AnalyticalLeoStationKeepingResponse

class TestAnalyticalLeoStationKeepingResponse(unittest.TestCase):
    """AnalyticalLeoStationKeepingResponse unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> AnalyticalLeoStationKeepingResponse:
        """Test AnalyticalLeoStationKeepingResponse
            include_optional is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `AnalyticalLeoStationKeepingResponse`
        """
        model = AnalyticalLeoStationKeepingResponse()
        if include_optional:
            return AnalyticalLeoStationKeepingResponse(
                delta_v = 1.337,
                maneuvering_duration = 1.337,
                mission_duration = 1.337,
                thrust_duration = 1.337,
                thruster_mean_duty_cycle = 1.337,
                total_impulse = 1.337,
                used_propellant = 1.337,
                number_of_burns = 56,
                mean_burn_duration_estimation = 1.337,
                drag_perturbation_enabled = True,
                mean_atmospheric_density = 1.337,
                mean_drag = 1.337,
                mean_drag_acceleration = 1.337,
                drag_to_thrust_ratio = 1.337,
                drag_delta_v = 1.337,
                maneuver_model = '',
                final_orbit = leo_station_keeping.models.orbit.Orbit(
                    inclination = 1.337, 
                    sma = 1.337, 
                    eccentricity = 1.337, 
                    parameters = leo_station_keeping.models.orbit_parameters.OrbitParameters(), 
                    advanced_parameters = leo_station_keeping.models.advanced_orbit_parameters.AdvancedOrbitParameters(
                        orbit_date = '', 
                        ascending_node_type = 'RAAN', 
                        raan = 1.337, 
                        mltan = 1.337, 
                        anomaly = 1.337, 
                        anomaly_type = 'TRUE', 
                        orbital_element_type = 'MEAN', 
                        perigee_argument = 1.337, ), ),
                errors = [
                    ''
                    ],
                warnings = [
                    ''
                    ]
            )
        else:
            return AnalyticalLeoStationKeepingResponse(
        )
        """

    def testAnalyticalLeoStationKeepingResponse(self):
        """Test AnalyticalLeoStationKeepingResponse"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
