# coding: utf-8

"""
    LEO Station Keeping API

    This mission allows to estimate the cost of station keeping maneuvers needed  to counter the effects of the atmospheric drag on the semi-major axis of a  spacecraft in low Earth orbit (up to an altitude of 1000 km).   <b>CHANGELOG</b> <ul>   <li><b>1.6.0</b> - 2024-07-15 - Add <b>Battery</b> schema to inputs of <b>NumericalLeoStationKeepingRequest</b> schema</li>, update SolarArray efficiency description, added SYSTEM output ephemerides type, corrected <b>onBoardAveragePower</b> description</li>   <li><b>1.5.0</b> - 2024-07-08 - Replace custom earth potential data with <b>customEarthPotentialConfiguration</b> in <b>EarthPotentialPerturbation</b> schema</li>   <li><b>1.4.0</b> - 2024-07-08 - Add <b>efficiency</b> to <b>SolarArray</b> schema</li>   <li><b>1.3.0</b> - 2024-07-08 - Replace <b>missionDateTime</b> by <b>initialDate</b> in <b>NumericalLeoStationKeepingRequest</b> schema</li>    <li><b>1.2.0</b> - 2024-07-03 - Add <b>atmosphericModel</b> to <b>DragPerturbation</b> schema</li>   <li><b>1.1.0</b> - 2024-06-27 - Map custom maneuvering strategy</li>   <li><b>1.0.0</b> - 2024-06-07 - First version of the API</li> </ul> 

    The version of the OpenAPI document: 1.6.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


import unittest

from leo_station_keeping.models.numerical_leo_station_keeping_response_orbital_ephemerides_osculating import NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating

class TestNumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating(unittest.TestCase):
    """NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating unit test stubs"""

    def setUp(self):
        pass

    def tearDown(self):
        pass

    def make_instance(self, include_optional) -> NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating:
        """Test NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating
            include_optional is a boolean, when False only required
            params are included, when True both required and
            optional params are included """
        # uncomment below to create an instance of `NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating`
        """
        model = NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating()
        if include_optional:
            return NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating(
                keplerian = leo_station_keeping.models.keplerian_ephemerides.KeplerianEphemerides(
                    true_anomaly = [
                        1.337
                        ], 
                    mean_anomaly = [
                        1.337
                        ], 
                    inclination = [
                        1.337
                        ], 
                    eccentric_anomaly = [
                        1.337
                        ], 
                    perigee_altitude = [
                        1.337
                        ], 
                    ltan = [
                        1.337
                        ], 
                    altitude = [
                        1.337
                        ], 
                    semi_major_axis = [
                        1.337
                        ], 
                    eccentricity = [
                        1.337
                        ], 
                    raan = [
                        1.337
                        ], ),
                cartesian = leo_station_keeping.models.cartesian_ephemerides.CartesianEphemerides(
                    x = [
                        1.337
                        ], 
                    y = [
                        1.337
                        ], 
                    z = [
                        1.337
                        ], 
                    vx = [
                        1.337
                        ], 
                    vy = [
                        1.337
                        ], 
                    vz = [
                        1.337
                        ], )
            )
        else:
            return NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating(
        )
        """

    def testNumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating(self):
        """Test NumericalLeoStationKeepingResponseOrbitalEphemeridesOsculating"""
        # inst_req_only = self.make_instance(include_optional=False)
        # inst_req_and_optional = self.make_instance(include_optional=True)

if __name__ == '__main__':
    unittest.main()
